Package: org.codehaus.groovy.tools.groovydoc

## [Java] Class SimpleGroovyClassDoc

- org.codehaus.groovy.tools.groovydoc.SimpleGroovyClassDoc

- All Implemented Interfaces and Traits:
    GroovyClassDoc

      public class SimpleGroovyClassDoc
      extends SimpleGroovyAbstractableElementDoc

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static Pattern` | `CODE_REGEX` |
    `static String` | `DOCROOT_PATTERN` |
    `static String` | `DOCROOT_PATTERN2` |
    `static Pattern` | `LINK_REGEX` |
    `static Pattern` | `LITERAL_REGEX` |
    `static Pattern` | `NAME_ARGS_REGEX` |
    `static Pattern` | `REF_LABEL_REGEX` |
    `static Pattern` | `SPLIT_ARGS_REGEX` |
    `static Pattern` | `TAG_REGEX` |

  - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `String` | `fullPathName`
    `boolean` | `groovy`
    `String` | `nameWithTypeArgs`
    `GroovyClassDoc` | `outer`
    `String` | `superClassName`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `SimpleGroovyClassDoc (List<String> importedClassesAndPackages, Map<String, String> aliases, String name, List<LinkArgument> links)`
    `SimpleGroovyClassDoc (List<String> importedClassesAndPackages, Map<String, String> aliases, String name)`
    `SimpleGroovyClassDoc (List<String> importedClassesAndPackages, String name)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `boolean` | `add(GroovyConstructorDoc constructor)`
    `` | `boolean` | `add(GroovyFieldDoc field)`
    `` | `boolean` | `add(GroovyMethodDoc method)`
    `` | `boolean` | `addEnumConstant(GroovyFieldDoc field)`
    `` | `void` | `addInterfaceName(String className)`
    `` | `boolean` | `addNested(GroovyClassDoc nestedClass)`
    `` | `boolean` | `addProperty(GroovyFieldDoc property)`
    `` | `String` | `commentText()`
    `` | `GroovyConstructorDoc[]` | `constructors()` returns a sorted array of constructors
    `` | `GroovyConstructorDoc[]` | `constructors(boolean filter)`
    `` | `static String` | `decodeSpecialSymbols(String text)`
    `` | `boolean` | `definesSerializableFields()`
    `` | `static String` | `encodeAngleBrackets(String text)`
    `` | `static String` | `encodeAngleBracketsInTagBody(String text, Pattern regex)` Replaces angle brackets inside a tag.
    `` | `static String` | `encodeSpecialSymbols(String text)`
    `` | `GroovyFieldDoc[]` | `enumConstants()` returns a sorted array of enum constants
    `` | `GroovyFieldDoc[]` | `fields()` returns a sorted array of fields
    `` | `GroovyFieldDoc[]` | `fields(boolean filter)`
    `` | `GroovyClassDoc` | `findClass(String className)`
    `` | `String` | `firstSentenceCommentText()`
    `` | `String` | `getDocUrl(String type)`
    `` | `String` | `getDocUrl(String type, boolean full)`
    `` | `static String` | `getDocUrl(String type, boolean full, List<LinkArgument> links, String relativePath, GroovyRootDoc rootDoc, SimpleGroovyClassDoc classDoc)`
    `` | `String` | `getFullPathName()`
    `` | `String` | `getNameWithTypeArgs()`
    `` | `GroovyClassDoc` | `getOuter()`
    `` | `List<GroovyClassDoc>` | `getParentClasses()`
    `` | `Set<GroovyClassDoc>` | `getParentInterfaces()`
    `` | `String` | `getRelativeRootPath()`
    `` | `String` | `getSuperClassName()`
    `` | `GroovyClassDoc[]` | `importedClasses()`
    `` | `GroovyPackageDoc[]` | `importedPackages()`
    `` | `GroovyClassDoc[]` | `innerClasses()` returns a sorted array of nested classes and interfaces
    `` | `GroovyClassDoc[]` | `innerClasses(boolean filter)`
    `` | `GroovyType[]` | `interfaceTypes()`
    `` | `GroovyClassDoc[]` | `interfaces()`
    `` | `boolean` | `isExternalizable()`
    `` | `boolean` | `isGroovy()`
    `` | `boolean` | `isPrimitive()`
    `` | `boolean` | `isSerializable()`
    `` | `GroovyMethodDoc[]` | `methods()` returns a sorted array of methods
    `` | `GroovyMethodDoc[]` | `methods(boolean filter)`
    `` | `GroovyFieldDoc[]` | `properties()` returns a sorted array of properties
    `` | `String` | `qualifiedTypeName()`
    `` | `String` | `replaceAllTags(String self, String s1, String s2, Pattern regex)`
    `` | `static String` | `replaceAllTags(String self, String s1, String s2, Pattern regex, List<LinkArgument> links, String relPath, GroovyRootDoc rootDoc, SimpleGroovyClassDoc classDoc)`
    `` | `String` | `replaceAllTagsCollated(String self, String preKey, String postKey, String valueSeparator, String postValues, Pattern regex)`
    `` | `String` | `replaceTags(String comment)`
    `` | `GroovyFieldDoc[]` | `serializableFields()`
    `` | `GroovyMethodDoc[]` | `serializationMethods()`
    `` | `void` | `setFullPathName(String fullPathName)`
    `` | `void` | `setGroovy(boolean isgroovy)`
    `` | `void` | `setNameWithTypeArgs(String nameWithTypeArgs)`
    `` | `void` | `setOuter(GroovyClassDoc outer)`
    `` | `void` | `setSuperClass(GroovyClassDoc doc)`
    `` | `void` | `setSuperClassName(String className)`
    `` | `String` | `simpleTypeName()`
    `` | `boolean` | `subclassOf(GroovyClassDoc gcd)`
    `` | `GroovyClassDoc` | `superclass()`
    `` | `GroovyType` | `superclassType()`
    `` | `String` | `typeName()`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class SimpleGroovyAbstractableElementDoc` | `isAbstract, setAbstract`
    `class SimpleGroovyProgramElementDoc` | `addAnnotationRef, annotations, containingClass, containingPackage, isFinal, isPackagePrivate, isPrivate, isProtected, isPublic, isStatic, modifierSpecifier, modifiers, qualifiedName, setContainingPackage, setFinal, setPackagePrivate, setPrivate, setProtected, setPublic, setStatic`
    `class SimpleGroovyDoc` | `calculateFirstSentence, commentText, compareTo, firstSentenceCommentText, getRawCommentText, getTypeDescription, getTypeSourceDescription, isAnnotationType, isAnnotationTypeElement, isClass, isConstructor, isDeprecated, isEnum, isEnumConstant, isError, isException, isField, isIncluded, isInterface, isMethod, isOrdinaryClass, isScript, isTrait, name, setCommentText, setDeprecated, setFirstSentenceCommentText, setRawCommentText, setScript, setTokenType, tags, toString, tokenType`
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### public static final Pattern CODE_REGEX

    - #### public static final String DOCROOT_PATTERN

    - #### public static final String DOCROOT_PATTERN2

    - #### public static final Pattern LINK_REGEX

    - #### public static final Pattern LITERAL_REGEX

    - #### public static final Pattern NAME_ARGS_REGEX

    - #### public static final Pattern REF_LABEL_REGEX

    - #### public static final Pattern SPLIT_ARGS_REGEX

    - #### public static final Pattern TAG_REGEX

  - ### Property Detail

    - #### String fullPathName

    - #### boolean groovy

    - #### String nameWithTypeArgs

    - #### GroovyClassDoc outer

    - #### String superClassName

  - ### Constructor Detail

    - #### public SimpleGroovyClassDoc(List<String> importedClassesAndPackages, Map<String, String> aliases, String name, List<LinkArgument> links)

    - #### public SimpleGroovyClassDoc(List<String> importedClassesAndPackages, Map<String, String> aliases, String name)

    - #### public SimpleGroovyClassDoc(List<String> importedClassesAndPackages, String name)

  - ### Method Detail

    - #### public boolean add(GroovyConstructorDoc constructor)

    - #### public boolean add(GroovyFieldDoc field)

    - #### public boolean add(GroovyMethodDoc method)

    - #### public boolean addEnumConstant(GroovyFieldDoc field)

    - #### public void addInterfaceName(String className)

    - #### public boolean addNested(GroovyClassDoc nestedClass)

    - #### public boolean addProperty(GroovyFieldDoc property)

    - #### public String commentText()

    - #### public GroovyConstructorDoc[] constructors()

      returns a sorted array of constructors

    - #### public GroovyConstructorDoc[] constructors(boolean filter)

    - #### public static String decodeSpecialSymbols(String text)

    - #### public boolean definesSerializableFields()

    - #### public static String encodeAngleBrackets(String text)

    - #### public static String encodeAngleBracketsInTagBody(String text, Pattern regex)

      Replaces angle brackets inside a tag.

      Parameters:
        `text` - GroovyDoc text to process
        `regex` - has to capture tag name in group 1 and tag body in group 2

    - #### public static String encodeSpecialSymbols(String text)

    - #### public GroovyFieldDoc[] enumConstants()

      returns a sorted array of enum constants

    - #### public GroovyFieldDoc[] fields()

      returns a sorted array of fields

    - #### public GroovyFieldDoc[] fields(boolean filter)

    - #### public GroovyClassDoc findClass(String className)

    - #### public String firstSentenceCommentText()

    - #### public String getDocUrl(String type)

    - #### public String getDocUrl(String type, boolean full)

    - #### public static String getDocUrl(String type, boolean full, List<LinkArgument> links, String relativePath, GroovyRootDoc rootDoc, SimpleGroovyClassDoc classDoc)

    - #### public String getFullPathName()

    - #### public String getNameWithTypeArgs()

    - #### public GroovyClassDoc getOuter()

    - #### public List<GroovyClassDoc> getParentClasses()

    - #### public Set<GroovyClassDoc> getParentInterfaces()

    - #### public String getRelativeRootPath()

    - #### public String getSuperClassName()

    - #### public GroovyClassDoc[] importedClasses()

    - #### public GroovyPackageDoc[] importedPackages()

    - #### public GroovyClassDoc[] innerClasses()

      returns a sorted array of nested classes and interfaces

    - #### public GroovyClassDoc[] innerClasses(boolean filter)

    - #### public GroovyType[] interfaceTypes()

    - #### public GroovyClassDoc[] interfaces()

    - #### public boolean isExternalizable()

    - #### public boolean isGroovy()

    - #### public boolean isPrimitive()

    - #### public boolean isSerializable()

    - #### public GroovyMethodDoc[] methods()

      returns a sorted array of methods

    - #### public GroovyMethodDoc[] methods(boolean filter)

    - #### public GroovyFieldDoc[] properties()

      returns a sorted array of properties

    - #### public String qualifiedTypeName()

    - #### public String replaceAllTags(String self, String s1, String s2, Pattern regex)

    - #### public static String replaceAllTags(String self, String s1, String s2, Pattern regex, List<LinkArgument> links, String relPath, GroovyRootDoc rootDoc, SimpleGroovyClassDoc classDoc)

    - #### public String replaceAllTagsCollated(String self, String preKey, String postKey, String valueSeparator, String postValues, Pattern regex)

    - #### public String replaceTags(String comment)

    - #### public GroovyFieldDoc[] serializableFields()

    - #### public GroovyMethodDoc[] serializationMethods()

    - #### public void setFullPathName(String fullPathName)

    - #### public void setGroovy(boolean isgroovy)

    - #### public void setNameWithTypeArgs(String nameWithTypeArgs)

    - #### public void setOuter(GroovyClassDoc outer)

    - #### public void setSuperClass(GroovyClassDoc doc)

    - #### public void setSuperClassName(String className)

    - #### public String simpleTypeName()

    - #### public boolean subclassOf(GroovyClassDoc gcd)

    - #### public GroovyClassDoc superclass()

    - #### public GroovyType superclassType()

    - #### public String typeName()